
/*  A Bison parser, made from parser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NODE	258
#define	AKOR	259
#define	BKOR	260
#define	NOTE	261
#define	FROMS	262
#define	TOS	263
#define	POSITION	264
#define	BOOKDEL	265
#define	NIL	266
#define	SENTE	267
#define	GOTE	268
#define	EVENT	269
#define	DATE	270
#define	ROUND	271
#define	SITE	272
#define	RESULT	273
#define	OPENING	274
#define	NAME	275
#define	EMAIL	276
#define	COUNTRY	277
#define	BLACK_GRADE	278
#define	WHITE_GRADE	279
#define	COMMENT	280
#define	SOURCE	281
#define	VENUE	282
#define	PROAM	283
#define	LEAF	284
#define	BAD	285
#define	TEXT	286
#define	MOVE	287
#define	NUM	288

#line 1 "parser.y"

/*  shogiopening
 *  Copyright (C) 2000 Sverre Hvammen Johansen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "scanner.h"
#include <glib.h>
#include "graph.h"
#include "board.h"
#include "hash.h"
#include "ext.h"
#include "ask.h"

  extern int yyline;
  t_graph *graph; 
  gboolean fold;

  extern void yyerror(char *text);
  extern int yylex(); 
  t_data *data;

#line 39 "parser.y"
typedef union {
        long val;
        char *string;
        GSList *glist;
	t_arc *arc;
        t_node *node;
        t_data *data;
       } YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		277
#define	YYFLAG		-32768
#define	YYNTBASE	60

#define YYTRANSLATE(x) ((unsigned)(x) <= 288 ? yytranslate[x] : 95)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,    37,     2,     2,     2,     2,    36,
    39,     2,     2,     2,     2,    40,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    41,     2,     2,
    59,     2,     2,     2,    38,    42,     2,     2,     2,     2,
    56,     2,     2,     2,     2,    53,     2,    54,     2,    58,
     2,    57,    55,     2,     2,     2,    43,     2,     2,     2,
    34,    44,    35,     2,     2,     2,     2,    51,     2,     2,
     2,     2,    48,     2,     2,     2,    49,    45,     2,    46,
     2,    52,     2,    50,    47,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     6,     9,    11,    12,    16,    19,    21,    26,
    31,    36,    41,    46,    51,    56,    61,    66,    71,    76,
    81,    86,    91,    96,   101,   106,   111,   115,   117,   120,
   122,   123,   128,   132,   134,   135,   143,   144,   147,   148,
   149,   151,   157,   160,   161,   166,   171,   172,   259,   261,
   266,   270,   274,   276,   280,   283,   285,   289,   293,   297,
   301,   305,   309,   313,   317,   321,   325,   329,   333,   337,
   341,   345,   348,   351,   352,   355,   358,   361,   362,   364,
   365,   370,   371,   374,   375,   376,   378,   381,   382,   385,
   388,   391,   394,   397,   400,   403,   404,   425,   429,   432,
   435,   438,   441,   444,   447,   450
};

static const short yyrhs[] = {    70,
    92,    94,     0,    61,     0,    61,    62,     0,    62,     0,
     0,    63,    64,    66,     0,    64,    65,     0,    65,     0,
    34,    12,    31,    35,     0,    34,    13,    31,    35,     0,
    34,    14,    31,    35,     0,    34,    15,    31,    35,     0,
    34,    16,    31,    35,     0,    34,    17,    31,    35,     0,
    34,    18,    31,    35,     0,    34,    19,    31,    35,     0,
    34,    20,    31,    35,     0,    34,    21,    31,    35,     0,
    34,    22,    31,    35,     0,    34,    23,    31,    35,     0,
    34,    24,    31,    35,     0,    34,    25,    31,    35,     0,
    34,    26,    31,    35,     0,    34,    14,    31,    35,     0,
    34,    27,    31,    35,     0,    34,    28,    31,    35,     0,
    34,    31,    35,     0,    68,     0,    31,    68,     0,    31,
     0,     0,    69,    32,    67,    68,     0,    69,    32,    67,
     0,    33,     0,     0,    36,    37,    33,    38,    36,    36,
    11,     0,     0,    71,    73,     0,     0,     0,    30,     0,
    36,    31,    72,    92,    39,     0,    74,    75,     0,     0,
    36,    31,    92,    39,     0,     7,    36,    74,    39,     0,
     0,    37,    36,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    39,    80,    80,     0,    11,     0,
    36,    82,    79,    39,     0,    40,    41,    42,     0,    40,
    41,    43,     0,    11,     0,    36,    81,    39,     0,    81,
    82,     0,    82,     0,    37,    44,    45,     0,    37,    44,
    46,     0,    37,    44,    47,     0,    37,    44,    48,     0,
    37,    44,    49,     0,    37,    44,    50,     0,    37,    44,
    51,     0,    37,    44,    52,     0,    37,    44,    53,     0,
    37,    44,    54,     0,    37,    44,    55,     0,    37,    44,
    56,     0,    37,    44,    57,     0,    37,    44,    42,     0,
    37,    44,    58,     0,     4,    33,     0,     4,    11,     0,
     0,     5,    33,     0,     5,    31,     0,     6,    31,     0,
     0,    29,     0,     0,     9,    36,    77,    39,     0,     0,
    10,    33,     0,     0,     0,    89,     0,    89,    91,     0,
     0,    90,    91,     0,    12,    31,     0,    13,    31,     0,
    15,    31,     0,    14,    31,     0,    19,    31,     0,    18,
    31,     0,     0,    37,    33,    59,    37,    55,    36,     3,
    83,    84,    85,    88,    93,    76,     8,    36,    71,    39,
    86,    87,    39,     0,    37,    33,    37,     0,    94,    36,
     0,    94,    39,     0,    94,    37,     0,    94,    33,     0,
    94,    40,     0,    94,    31,     0,    94,    11,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    67,    72,    78,    80,    88,    92,    94,    95,    97,    98,
    99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
   109,   110,   111,   112,   113,   114,   115,   117,   118,   121,
   122,   125,   134,   143,   144,   146,   147,   149,   151,   154,
   155,   157,   160,   161,   163,   165,   166,   168,   181,   182,
   184,   185,   187,   188,   190,   191,   193,   194,   195,   196,
   197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
   207,   209,   210,   211,   213,   214,   215,   216,   219,   220,
   222,   223,   225,   226,   228,   229,   231,   232,   232,   234,
   235,   236,   237,   238,   239,   241,   253,   259,   262,   263,
   264,   265,   266,   267,   268,   269
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NODE","AKOR",
"BKOR","NOTE","FROMS","TOS","POSITION","BOOKDEL","NIL","SENTE","GOTE","EVENT",
"DATE","ROUND","SITE","RESULT","OPENING","NAME","EMAIL","COUNTRY","BLACK_GRADE",
"WHITE_GRADE","COMMENT","SOURCE","VENUE","PROAM","LEAF","BAD","TEXT","MOVE",
"NUM","'['","']'","'('","'#'","'A'","')'","'.'","':'","'B'","'W'","'\\'","'l'",
"'n'","'s'","'g'","'k'","'r'","'b'","'p'","'L'","'N'","'S'","'G'","'R'","'P'",
"'='","MAIN","GAMES","ONE_GAME","@1","GAME_DATA","DATA","GAME","MAYBEE_TEXT",
"MOVES","MAYBEE_NUM","HEAD","ARCS","BAD_PART","ARC","ARCSX","ARCX","FROMS_PART",
"BOARD_POSITION","SQUARE","COLOR","HAND","PICES","PICE","APART","BPART","LEAF_PART",
"PPART","LPART","DATA_PART","DATA_PART2","@2","DATA_PART3","GAME_NODE","@3",
"TAIL", NULL
};
#endif

static const short yyr1[] = {     0,
    60,    60,    61,    61,    63,    62,    64,    64,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    66,    66,    67,
    67,    68,    68,    69,    69,    70,    70,    71,    71,    72,
    72,    73,    74,    74,    75,    76,    76,    77,    78,    78,
    79,    79,    80,    80,    81,    81,    82,    82,    82,    82,
    82,    82,    82,    82,    82,    82,    82,    82,    82,    82,
    82,    83,    83,    83,    84,    84,    84,    84,    85,    85,
    86,    86,    87,    87,    88,    88,    89,    90,    89,    91,
    91,    91,    91,    91,    91,    93,    92,    92,    94,    94,
    94,    94,    94,    94,    94,    94
};

static const short yyr2[] = {     0,
     3,     1,     2,     1,     0,     3,     2,     1,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     3,     1,     2,     1,
     0,     4,     3,     1,     0,     7,     0,     2,     0,     0,
     1,     5,     2,     0,     4,     4,     0,    86,     1,     4,
     3,     3,     1,     3,     2,     1,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     2,     2,     0,     2,     2,     2,     0,     1,     0,
     4,     0,     2,     0,     0,     1,     2,     0,     2,     2,
     2,     2,     2,     2,     2,     0,    20,     3,     2,     2,
     2,     2,     2,     2,     2,     0
};

static const short yydefact[] = {     5,
     0,     2,     4,     0,     0,     0,     3,     0,    35,     8,
     0,   106,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    35,    34,     7,     6,    28,     0,     0,     1,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    27,    29,    31,
    98,     0,   105,   104,   102,    99,   101,   100,   103,     0,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    25,    26,    30,    33,     0,
     0,    32,     0,    36,     0,    74,     0,    78,    73,    72,
     0,     0,    80,    76,    75,    77,    79,    88,    96,    86,
     0,    47,     0,     0,     0,     0,     0,     0,    87,    89,
     0,     0,    90,    91,    93,    92,    95,    94,    44,     0,
     0,    39,     0,    46,    43,     0,     0,     0,    82,    38,
     0,    40,     0,    84,    45,    41,     0,     0,     0,     0,
     0,     0,     0,    83,    97,    42,     0,    81,    49,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    70,    57,
    58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
    68,    69,    71,     0,    50,     0,    51,    52,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    53,     0,     0,     0,
    56,    48,    54,    55,     0,     0,     0
};

static const short yydefgoto[] = {   275,
     2,     3,     4,     9,    10,    35,    89,    36,    37,     5,
   136,   147,   140,   131,   135,   122,   153,   161,   167,   269,
   270,   163,    98,   103,   108,   144,   150,   109,   110,   111,
   119,    12,   112,    39
};

static const short yypact[] = {    77,
   -14,    88,-32768,    98,   115,   127,-32768,   123,    86,-32768,
   133,-32768,   129,   137,   138,   139,   140,   141,   142,   143,
   144,   145,   146,   147,   148,   149,   150,   151,   152,   154,
   156,   157,-32768,-32768,-32768,-32768,   160,    69,    94,   158,
   161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
   171,   172,   173,   174,   175,   176,   177,-32768,-32768,   182,
-32768,   178,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   159,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   124,   131,
   203,-32768,   180,-32768,   181,   183,    96,   153,-32768,-32768,
   -27,   186,   189,-32768,-32768,-32768,-32768,   155,-32768,    97,
    97,   212,   190,   191,   192,   193,   194,   195,-32768,-32768,
   184,   185,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   196,
    85,-32768,   197,-32768,-32768,    87,   115,   198,   179,-32768,
   188,   200,   199,   221,-32768,-32768,   115,   201,   204,   202,
   205,   206,   207,-32768,-32768,-32768,   -10,-32768,-32768,   208,
   -10,   209,   210,   -10,   -37,   211,   215,   -10,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   122,-32768,   -10,-32768,-32768,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,   -10,
   -10,   -10,   -10,   -10,   216,    -9,-32768,   208,    -9,   -15,
-32768,-32768,-32768,-32768,   233,   234,-32768
};

static const short yypgoto[] = {-32768,
-32768,   187,-32768,-32768,   227,-32768,-32768,    72,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -161,-32768,   -30,
-32768,  -115,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   132,   -29,-32768,-32768
};


#define	YYLAST		255


static const short yytable[] = {   164,
   159,   267,   168,   104,   169,   105,   186,   170,   171,   172,
   173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
   183,   162,     6,   273,   189,   160,   268,   190,   191,   192,
   193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
   203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
   213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
   253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
   263,   264,   265,    59,    63,    61,    99,   141,   113,   114,
   115,   116,     1,   -37,   117,   118,    32,   151,    33,     8,
   133,    -5,   138,   134,    64,   139,    65,    62,   100,    66,
    67,     8,    68,    69,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    11,   271,    31,   274,   -35,    33,   101,   102,    13,
    92,   -85,   -85,   187,   188,    38,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    96,    57,    93,    97,   143,     7,    33,
    58,    60,   130,    70,    91,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    94,    90,    95,   106,   107,   121,   129,
   123,   124,   125,   126,   127,   128,   145,   137,   142,   146,
   149,   132,   276,   277,   148,    34,   154,   152,   272,     0,
   155,   157,   120,   156,   162,   158,     0,     0,     0,   166,
     0,   184,   165,   185,   266
};

static const short yycheck[] = {   161,
    11,    11,   164,    31,    42,    33,   168,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
    58,    37,    37,    39,   186,    36,    36,   189,   190,   191,
   192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
   202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
   212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
   252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
   262,   263,   264,    32,    11,    37,    11,   137,    12,    13,
    14,    15,    36,    37,    18,    19,    31,   147,    33,    34,
    36,    34,    36,    39,    31,    39,    33,    59,    33,    36,
    37,    34,    39,    40,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    37,   268,    31,   270,    32,    33,     5,     6,    33,
    89,     7,     8,    42,    43,    33,    38,    31,    31,    31,
    31,    31,    31,    31,    31,    31,    31,    31,    31,    31,
    31,    31,    31,     3,    31,    55,     4,     9,     2,    33,
    35,    32,     8,    36,    36,    35,    35,    35,    35,    35,
    35,    35,    35,    35,    35,    35,    35,    35,    35,    35,
    35,    35,    31,    11,    37,    36,    31,    29,     7,    36,
    31,    31,    31,    31,    31,    31,    39,    31,    31,    30,
    10,    36,     0,     0,    36,     9,    33,    37,   269,    -1,
    39,    36,   111,    39,    37,    39,    -1,    -1,    -1,    40,
    -1,    41,    44,    39,    39
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
YYPARSE_RETURN_TYPE yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 68 "parser.y"
{
  fold= FALSE;
  graph->main= yyvsp[-1].node;
;
    break;}
case 2:
#line 73 "parser.y"
{
  fold= TRUE;
  graph->main= yyvsp[0].node;
;
    break;}
case 3:
#line 79 "parser.y"
{ yyvsp[-1].node->tos= g_slist_prepend (yyvsp[-1].node->tos, yyvsp[0].arc); ;
    break;}
case 4:
#line 81 "parser.y"
{ 
  t_node *n;
  n= new_node (graph, 0, NULL);
  n->tos= g_slist_prepend(NULL, yyvsp[0].arc);
  yyval.node= n;
;
    break;}
case 5:
#line 89 "parser.y"
{
  data= new_data (graph);
;
    break;}
case 6:
#line 92 "parser.y"
{ yyval.arc= yyvsp[0].arc;;
    break;}
case 9:
#line 97 "parser.y"
{data->sente=yyvsp[-1].string;;
    break;}
case 10:
#line 98 "parser.y"
{data->gote=yyvsp[-1].string;;
    break;}
case 11:
#line 99 "parser.y"
{data->event=yyvsp[-1].string;;
    break;}
case 12:
#line 100 "parser.y"
{data->date=yyvsp[-1].string;;
    break;}
case 15:
#line 103 "parser.y"
{data->result=yyvsp[-1].string;;
    break;}
case 16:
#line 104 "parser.y"
{data->opening=yyvsp[-1].string;;
    break;}
case 29:
#line 119 "parser.y"
{yyval.arc= yyvsp[0].arc;;
    break;}
case 31:
#line 123 "parser.y"
{ yyval.string= NULL; ;
    break;}
case 32:
#line 126 "parser.y"
{
  t_node *n;
  n= new_node (graph, 0, yyvsp[-1].string);
  n->tos= g_slist_prepend(NULL,yyvsp[0].arc);
  yyval.arc= new_arc(graph, yyvsp[-2].string, n);
;
    break;}
case 33:
#line 135 "parser.y"
{ 
  t_node *n;
  n= new_node (graph, 0, yyvsp[0].string);
  n->leaf= 1;
  n->data= data;
  yyval.arc= new_arc(graph, yyvsp[-1].string, n);
;
    break;}
case 34:
#line 143 "parser.y"
{;
    break;}
case 38:
#line 150 "parser.y"
{ yyval.glist=g_slist_prepend(yyvsp[-1].glist, yyvsp[0].arc); ;
    break;}
case 39:
#line 152 "parser.y"
{ yyval.glist=NULL ;
    break;}
case 40:
#line 154 "parser.y"
{yyval.val= 0;;
    break;}
case 41:
#line 155 "parser.y"
{yyval.val= 1;;
    break;}
case 42:
#line 158 "parser.y"
{ yyval.arc= new_arc(graph, yyvsp[-3].string, yyvsp[-1].node); yyval.arc->bad= yyvsp[-2].val; ;
    break;}
case 75:
#line 213 "parser.y"
{ yyval.string=NULL;;
    break;}
case 76:
#line 214 "parser.y"
{ yyval.string=yyvsp[0].string;;
    break;}
case 77:
#line 215 "parser.y"
{ yyval.string=yyvsp[0].string;;
    break;}
case 78:
#line 217 "parser.y"
{ yyval.string=NULL;;
    break;}
case 79:
#line 219 "parser.y"
{ yyval.val= 1;;
    break;}
case 80:
#line 220 "parser.y"
{ yyval.val= 0;;
    break;}
case 85:
#line 228 "parser.y"
{yyval.data= NULL;;
    break;}
case 88:
#line 232 "parser.y"
{ yyval.data= new_data(graph); ;
    break;}
case 89:
#line 232 "parser.y"
{yyval.data= yyvsp[-1].data;;
    break;}
case 90:
#line 234 "parser.y"
{ yyvsp[-2].data->sente= yyvsp[0].string; ;
    break;}
case 91:
#line 235 "parser.y"
{ yyvsp[-2].data->gote= yyvsp[0].string; ;
    break;}
case 92:
#line 236 "parser.y"
{ yyvsp[-2].data->date= yyvsp[0].string; ;
    break;}
case 93:
#line 237 "parser.y"
{ yyvsp[-2].data->event= yyvsp[0].string; ;
    break;}
case 94:
#line 238 "parser.y"
{ yyvsp[-2].data->opening= yyvsp[0].string; ;
    break;}
case 95:
#line 239 "parser.y"
{ yyvsp[-2].data->result= yyvsp[0].string; ;
    break;}
case 96:
#line 246 "parser.y"
{ t_node *n;
  n= new_node_by_number(graph, yyvsp[-9].val, yyvsp[-2].string);
  n->leaf= yyvsp[-1].val;
  n->data= yyvsp[0].data;
  yyval.node= n;
;
    break;}
case 97:
#line 257 "parser.y"
{ yyvsp[-8].node->tos= yyvsp[-4].glist;
  yyval.node=yyvsp[-8].node;;
    break;}
case 98:
#line 260 "parser.y"
{ yyval.node= find_node_by_number(yyvsp[-1].val);;
    break;}
case 102:
#line 265 "parser.y"
{;
    break;}
case 104:
#line 267 "parser.y"
{;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 272 "parser.y"


void yyerror(char *text)
{
  char s[1000];
  sprintf (s,_("Error reading database at line %d: %s\n"),yyline, text);
  display_error (s);
}

t_graph *build_graph(char *name, gboolean *foldp)
{
  if (!init_scanner(name))
    {
      char s[5000];
      sprintf(s,_("Could not open %s"), name);
      display_error(s);
      return(NULL);
    }
  graph= new_graph();
  g_slist_push_allocator(graph->gslist);
  hash_number_init();
  yyparse();
  cleanup_scanner();
  *foldp=fold;
  hash_number_final();
  g_slist_pop_allocator();
  if (yynerrs) 
    {
      free_graph (graph);
      return NULL;
    }
  else
    return (graph);
}

